package de.fhwi.codecover;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;



public class Integrations2Test {
	
	WahrFalsch objWF;
	Fakultaet objF;
	Fibonacci objFib;
	

	/*Wird vor jedem Testaufruf ausgeführt*/
	@Before
	public void setUp() throws Exception {
		
		objWF = new WahrFalsch();
		objF = new Fakultaet();
		objFib = new Fibonacci();
	}

	/*Wird nach jedem Testaufruf ausgeführt*/
	@After
	public void tearDown() throws Exception {
		
	}

	// Testet ob beide Variablen wahr sind
	@Test
	public void WahrFalsch1(){
		String expected = "beide wahr";
		
		try{
			objWF.TestBeideWahr(true, true);
		}catch (Exception e) {
			fail("TestWahrFalsch1 fehlgeschlagen");
			e.printStackTrace();
		}
		
		assertEquals(expected, objWF.getString());
	}
	// testet ob Variablen nicht gleich sind, faengt erzeugte Exception
	@Test
	public void WahrFalsch2(){
		String expected = "nicht beide wahr";
		
		try{
			objWF.TestBeideWahr(false, true);
			fail();		// faengt die Exception
		}catch (Exception e) {
			assertEquals(expected, objWF.getString());
			//e.printStackTrace();		// auskommentiert, da ansonsten der gesamte Stacktrace 
										// auf der Konsole ausgegeben wird, wird schnell unuebersichtlich
			System.out.println("Variablen sind nicht gleich! Exception getestet");
		}		
	}
	
	@Test
	public void WahrFalsch3(){
		String expected = "a oder b wahr";
		
		try{
			objWF.TestOder(false, true);
		}catch (Exception e) {
			fail("TestWahrFalsch3 fehlgeschlagen");
			e.printStackTrace();
		}
		
		assertEquals(expected, objWF.getString());
		
	}
	
	@Test
	public void WahrFalsch4(){
		String expected = "keiner wahr";
		
		try{
			objWF.TestOder(false, false);
			fail();
		}catch (Exception e) {
			assertEquals(expected, objWF.getString());
			//e.printStackTrace();
			System.out.println("Keine Variable Wahr. Exception getestet");
		}	
	}
	// ---------------------------------------------------------------------------
	
	// Test von einzelnen Variablen
	@Test
	public void Fak(){
		int expected = 120;
		int actual = 0;
		
		try{
			actual = objF.rekursiv(5);
		}catch (Exception e) {
			fail("Falsches Ergebnis");
			e.printStackTrace();
		}
		assertEquals(expected, actual);		// vergleicht den erwarteten Wert mit dem berechnetem Wert
		
	}
	
	// Test von Feldern
	@Test
	public void Fib(){
		int[] expected = {0,1,1,2,3,5};
		int[] actual = {0,0,0,0,0,0};
		try {
			actual = objFib.iterativ(6);
		} catch (Exception e) {
			fail();
			e.printStackTrace();
		}
		for(int i=0;i<=5;i++){
			assertEquals(expected[i], actual[i]);
		}
		
		
	}
}

